import sys


def solve(n, bads):
    answer = 0
    for i in range(1, n + 1):
        digits = set(map(int, str(i)))
        if not (digits & bads):
            answer += 1
    return answer


def main(infile, outfile):
    n = int(infile.readline())
    infile.readline()
    bads = set(map(int, infile.readline().split()))
    answer = solve(n, bads)
    print(answer)


if __name__ == '__main__':
    main(sys.stdin, sys.stdout)
