#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cmath>

using namespace std;

int solve();

#define ss second
#define ff first
#define y1 y111
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> ipair;
typedef pair <ll, ll> lpair;

const int MAXN = (int)2e5 + 7, IINF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7, MOD = (ll)1e9;

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
#else
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
	return 0;
}

int solve() {
	ull a;
	int n;

	cin >> n >> a;

	bool has_zero = 0, has_one = 0;
	int f_zero = 0, f_one = 0;

	for (int i = 0; i < n; ++i) {
		if ((1ull << i) & a) f_one = i, has_one = 1;
		else f_zero = i, has_zero = 1;
	}

	ull max_a, min_a;

	if (has_zero) {
		max_a = (1ull << f_zero) + a;
	} else {
		max_a = a;
	}

	if (has_one) {
		min_a = (1ull << f_one) ^ a;
	} else {
		min_a = a;
	}

	cout << min_a << ' ' << max_a << endl;

	return 0;
}