import random
import math
random.seed('personal05/coins')

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        print('Generating samples...')
        self.print_test([1, 2, 3, 4, 5, 18])

    def generate_min_tests(self):
        pass

    def generate_random_test(self, q, maxv):
        pass

    def generate_first_group_of_tests(self):
        print('Generating subtask1...')
        a = [i for i in range(1, 1001)]
        random.shuffle(a)
        self.print_test(a)

    def generate_second_group_of_tests(self):
        print('Generating subtask2...')
        a = []
        for i in range(10**6 // (5 * 10**3)):
            b = [i for i in range(1, 5001)]
            a.extend(b)
        random.shuffle(a)
        self.print_test(a)        

    def generate_third_group_of_tests(self):
        print('Generating subtask3...')
        a = [i for i in range(1, 10**6 + 1)]
        random.shuffle(a)
        self.print_test(a)        

    def print_test(self, queries):
        self.test_number += 1
        print('Generating test %d' % self.test_number)
        
        test_name = '{0:0=2d}'.format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(queries), file=test_file)
        print('\n'.join(map(str, queries)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        #Samples
        self.generate_samples() 
        
        #First group of tests
        self.generate_first_group_of_tests()
        
        #Second group of tests
        self.generate_second_group_of_tests()

        #Third group of tests
        self.generate_third_group_of_tests()

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
