#include <bits/stdc++.h>

struct Drone {
    int x;
    int y;
    int id;

    Drone() {}
    Drone(int x, int y, int id): x(x), y(y), id(id) {}

    int distance() const {
        return std::max(std::abs(x), std::abs(y));
    }

    bool operator < (const Drone &other) const {
        return distance() < other.distance(); 
    }
};

int main() {
    int n;
    scanf("%d", &n);
    std::vector<Drone> drones(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        drones[i] = Drone(x, y, i);
    }
    std::sort(drones.begin(), drones.end());
    std::vector<int> answer(n);
    for (int i = 0; i < n; i++) {
        if (drones[i].distance() <= i) {
            puts("-1");
            return 0;
        }
        answer[i] = drones[i].id;
    }
    for (int i = 0; i < n; i++) {
        printf("%d%c", drones[i].id + 1, " \n"[i == n - 1]);
    }
    return 0;
}
