#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> b(n), g(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> g[i];
    }
    vector<pair<int, pair<int, int>>> prs;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            prs.push_back({abs(b[i] - g[j]), {i, j}});
        }
    }
    sort(prs.begin(), prs.end());

    vector<pair<int, int>> ans;
    vector<bool> hb(n, true), hg(n, true);
    for (auto p : prs) {
        int i = p.second.first, j = p.second.second;
        if (hb[i] && hg[j]) {
            hb[i] = hg[j] = false;
            ans.emplace_back(i, j);
        }
    }

    for (int i = 0; i < n; i++) {
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
    }

    return 0;
}