#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 3);
	int n = atoi(argv[1]);
	int b = atoi(argv[2]);
	assert(b <= n);

	vector<vector<int>> graph(n);

	for (int i = 0; i < b; ++i) {
		graph[i].push_back(n - b + i);
	}

	string ans(n, '?');

	vector<bool> used(n);

	function<void(int, char)> dfs = [&](int v, char c) {
		used[v] = true;
		ans[v] = c;
		for (int to : graph[v]) {
			if (!used[to]) {
				dfs(to, c);
			}
		}
	};

	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i, 'a' + rnd.next(0, 25));
		}
	}

	cout << ans << "\n";

	return 0;
}