#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	string s;
	cin >> s;
	int n = szof(s);

	// ab != ac
	// ab != bc
	// ac != bc

	// b != c
	// a != b
	// ab != bc

	// aaaaaaaaabbbbb
	// bbbbbccccccccc

	vector<int> z(n);
	int l = 0, r = 0;
	ll ans = 0;
	for (int i = 1; i < n; ++i) {
		if (r > i) {
			z[i] = min(r - i, z[i - l]);
		}
		while (i + z[i] < n && s[z[i]] == s[i + z[i]]) {
			++z[i];
		}
		if (i + z[i] > r) {
			l = i;
			r = i + z[i];
		}
		if (i + z[i] == n && i < z[i] && i * 2 != z[i]) {
			--ans;
		}
	}

	ans += (ll) (n - 1) * (n - 2) / 2;
	// cerr << (ll) (n - 1) * (n - 2) / 2 << endl;

	for (int i = 2; i < n; i += 2) {
		if (z[i / 2] >= i / 2) {
			--ans;
		}
	}

	string t = s;
	reverse(t.begin(), t.end());

	vector<int> zt(n);
	l = 0, r = 0;
	for (int i = 1; i < n; ++i) {
		if (r > i) {
			zt[i] = min(r - i, zt[i - l]);
		}
		while (i + zt[i] < n && t[zt[i]] == t[i + zt[i]]) {
			++zt[i];
		}
		if (i + zt[i] > r) {
			l = i;
			r = i + zt[i];
		}
	}

	for (int i = 2; i < n; i += 2) {
		if (i / 2 * 3 != n && zt[i / 2] >= i / 2) {
			--ans;
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
