#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998244353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> graph(1);
	vector<int> parent = {-1};
	vector<int> sz = {1};
	vector<pii> ans = {{1, 1}};
	int tot_ans = 1;
	vector<int> pows2 = {1};
	for (int i = 1; i < n + 10; ++i) {
		pows2.push_back(mult(pows2.back(), 2));
	}
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		--p;
		graph.push_back({});
		graph[p].push_back(i);
		parent.push_back(p);
		sz.push_back(1);
		ans.push_back({1, 1});
		tot_ans += 1;
		int cur = p;
		while (cur != -1) {
			sz[cur]++;
			add(tot_ans, MOD - ans[cur].ss);
			ans[cur].ss = pows2[sz[cur]] - 1;
			ans[cur].ff = pows2[sz[cur]] - 1;
			for (int to : graph[cur]) {
				add(ans[cur].ss, mult(ans[to].ff, pows2[sz[cur] - sz[to]]));
				add(ans[cur].ss, MOD - ans[to].ff);
				add(ans[cur].ss, MOD - pows2[sz[to]] + 1);
				add(ans[cur].ff, mult(ans[to].ff, pows2[sz[cur] - sz[to]]));
			}
			add(tot_ans, ans[cur].ss);
			cur = parent[cur];
		}
		// for (pii num : ans) {
		// 	cerr << "(" << num.ff << ", " << num.ss << ") ";
		// }
		// cerr << endl;
		cout << tot_ans << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
