#include "testlib.h"
#include <string>
using namespace std;

const int MAXN = 100;
const int MAXM = 100;

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXM, "m");
    inf.readEoln();
    for (int i = 0; i < n; i++)
    {
        string s = inf.readString();
        ensuref(s.size() == m, "|s[%d]| != %d", i + 1, m);
        for (int j = 0; j < m; j++)
        {
            ensuref(s[j] == '+' || s[j] == '-' || s[j] == '.', "Incorrect s[%d][%d]", i + 1, j + 1);
            if (j < m - 1)
                 ensuref(s[j] != '.' || s[j + 1] == '.', "Not '.' after '.' in s[%d][%d]", i + 1, j + 1);
        }
    }
    inf.readEof();
    return 0;
}