#include <algorithm>
#include <vector>

#include "testlib.h"


int main(int argc, char* argv[]){
    registerValidation(argc, argv);
    int e9 = 1000 * 1000 * 1000;

    long long n = inf.readLong(1, (long long) e9 * e9, "n");
    inf.readEoln();

    int cnt = inf.readInt(1, 9, "digits count");
    inf.readEoln();

    std::vector<int> digits;
    for (int i = 0; i < cnt; ++i) {
        int d = inf.readInt(0, 9, "d_i");
        if (i < cnt - 1) {
            inf.readSpace();
        }
        ensuref(std::find(digits.begin(), digits.end(), d) == digits.end(), "Digits must be distinct");
        if (i > 0) {
            ensuref(d > digits.back(), "Digits must be in ascending order");
        }
        digits.push_back(d);
    }
    inf.readEoln();

    inf.readEof();
}
