import random
import sys


def solve(n, bads):
    nonzerobads = {x for x in bads if x != 0}
    ndigits = list(map(int, str(n)))

    length = len(ndigits)
    answer = 0

    for i in range(1, length):
        first = 9 - len(nonzerobads)
        others = 10 - len(bads)
        answer += first * (others ** (i - 1))

    for preflen in range(length):
        if preflen > 0 and ndigits[preflen - 1] in bads:
            break
        d = ndigits[preflen]
        s = 0 if preflen else 1
        first = len([x for x in range(s, 10) if x < d and x not in bads])
        others = 10 - len(bads)
        answer += first * (others ** (length - 1 - preflen))

    if not (set(ndigits) & bads):
        answer += 1

    return answer


def main(infile, outfile):
    n = int(infile.readline())
    infile.readline()
    bads = set(map(int, infile.readline().split()))
    answer = solve(n, bads)
    print(answer)


if __name__ == '__main__':
    main(sys.stdin, sys.stdout)
