#include "testlib.h"
#include <iostream> 

using namespace std;

typedef unsigned long long ull;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = rnd.next(1, atoi(argv[1])), k = rnd.next(0, n);

    vector <ull> bits;

    for (int i = 0; i < n; ++i)
    	bits.push_back(i);

    shuffle(bits.begin(), bits.end());

    ull a = 0;

    for (int i = 0; i < k; ++i)
    	a += (1ull << bits[i]);

    cout << n << ' ' << a << "\n";

    return 0;
}