#include "testlib.h"

const int MAX_N = 1e5;
const int MAX_C = 1e5;

int main(int argc, char* argv[])
{
  registerValidation(argc, argv);
  int n = inf.readInt(1, MAX_N, "n");
  inf.readEoln();
  for (int i = 0; i < n; i++) {
    int x = inf.readInt(-MAX_C, MAX_C, ("x[" + std::to_string(i + 1) + "]").c_str());
    inf.readSpace();
    int y = inf.readInt(-MAX_C, MAX_C, ("y[" + std::to_string(i + 1) + "]").c_str());
    inf.readEoln();
    ensuref(x != 0 || y != 0, "Drone #%d: initial place can't be (0, 0)", i + 1);
  }
  inf.readEof();
  return 0;
}
