#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>

using namespace std;

int solve();

#define ss second
#define ff first
#define y1 y111
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> ipair;
typedef pair <ll, ll > lpair;

const int MAXN = (int)2e5 + 7, IINF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7, MOD = (ll)1e9;
const double INFfl = (double)1e18 + 7, EPS = (double)1e-8, PI = atan2(0, -1);
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
#else
	cin.tie(0);
	cout.tie(0);
	#ifdef TASK
		freopen (TASK".in", "r", stdin);
		freopen (TASK".out", "w", stdout);
	#endif
#endif
	solve();
	return 0;
}

struct dron {
	int x, y, num;

	dron(int _x, int _y) : x(_x), y(_y), num(0) {};
	dron(){};

	int way() {
		x = abs(x), y = abs(y);
		return min(x, y) + (max(x, y) - min(x, y));
	}

	bool operator< (dron t) {
		return (way() < t.way());
	}
};


int solve() {
	int n;
	cin >> n;
	vector <dron> drons(n);
	for (int i = 0; i < n; ++i) {
		cin >> drons[i].x >> drons[i].y;
		drons[i].num = i + 1;
	}

	sort(drons.begin(), drons.end());

	for (size_t i = 0; i < drons.size(); ++i)
		if (drons[i].way() <= (int)i) {
			cout << -1;
			return 0;
		}

	for (auto d : drons)
		cout << d.num << " ";

	return 0;
}