#include <bits/stdc++.h>

using namespace std;

int mi;
int n, m;

int up[301][301], le[301][301], used[301][301][2];
string s[301];

void dfs(int x, int y, int q)
{
    used[x][y][q] = 1;
    //cout << "!" << x << " " << y << " " << q << endl;
    if (q == 1)
    {
        if (up[x][y] >= mi && used[x - mi + 1][y][0] == 0)
            dfs(x - mi + 1, y, 0);
        if (x + mi <= n && up[x + mi - 1][y] >= mi && used[x][y][0] == 0)
            dfs(x, y, 0);
        if (up[x][y + mi - 1] >= mi && used[x - mi + 1][y + mi - 1][0] == 0)
            dfs(x - mi + 1, y + mi - 1, 0);
        if (x + mi <= n && up[x + mi - 1][y + mi - 1] >= mi && used[x][y + mi - 1][0] == 0)
            dfs(x, y + mi - 1, 0);
        if (y + mi < m && le[x][y + mi] >= mi && used[x][y + 1][1] == 0)
            dfs(x, y + 1, 1);
        if (y > 0 && le[x][y + mi - 2] >= mi && used[x][y - 1][1] == 0)
            dfs(x, y - 1, 1);
    }
    else
    {
        if (le[x][y] >= mi && used[x][y - mi + 1][1] == 0)
            dfs(x, y - mi + 1, 1);
        if (y + mi <= m && le[x][y + mi - 1] >= mi && used[x][y][1] == 0)
            dfs(x, y, 1);
        if (le[x + mi - 1][y] >= mi && used[x + mi - 1][y - mi + 1][1] == 0)
            dfs(x + mi - 1, y - mi + 1, 1);
        if (y + mi <= m && le[x + mi - 1][y + mi - 1] >= mi && used[x + mi - 1][y][1] == 0)
            dfs(x + mi - 1, y, 1);
        if (x + mi < n && up[x + mi][y] >= mi && used[x + 1][y][0] == 0)
            dfs(x + 1, y, 0);
        if (x > 0 && up[x + mi - 2][y] >= mi && used[x - 1][y][0] == 0)
            dfs(x - 1, y, 0);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("A.in", "r", stdin);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
        if (s[i][0] == '.')
            le[i][0] = 1;
        for (int j = 1; j < m; j++)
        {
            if (s[i][j] == '#')
                le[i][j] = 0;
            else
                le[i][j] = le[i][j - 1] + 1;
        }
    }
    for (int j = 0; j < m; j++)
    {
        if (s[0][j] == '.')
            up[0][j] = 1;
        for (int i = 1; i < n; i++)
        {
            if (s[i][j] == '#')
                up[i][j] = 0;
            else
                up[i][j] = up[i - 1][j] + 1;
        }
    }
    /*
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            cout << le[i][j] << " " << up[i][j] << "   ";
        }
        cout << endl;
    }
    //*/
    int le = 0, ri = min(n, m) + 1;
    while (ri - le > 1)
    {
        mi = (le + ri) / 2;
        //cout << le << " " << mi << " " << ri << endl;
        bool d = 0;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                used[i][j][0] = used[i][j][1] = 0;
            }
        }
        for (int i = 0; i + mi <= n; i++)
        {
            if (up[i + mi - 1][0] >= mi && used[i][0][0] == 0)
                dfs(i, 0, 0);
        }
        for (int i = 0; i + mi <= n; i++)
        {
            if (used[i][m - 1][0])
            {
                d = 1;
                break;
            }
        }
        if (d)
            le = mi;
        else
            ri = mi;
    }
    cout << le << endl;
    return 0;
}
