#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> b(n), g(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> g[i];
    }

    vector<pair<int, int>> bs(n), gs(n);
    for (int i = 0; i < n; i++) {
        bs[i] = {b[i], i};
        gs[i] = {g[i], i};
    }

    random_shuffle(bs.begin(), bs.end());
    sort(gs.begin(), gs.end());

    set<pair<int, int>> gl;
    for (auto p : gs) {
        gl.insert(p);
    }

    vector<pair<int, int>> ans;
    for (auto bb : bs) {
        auto it = gl.lower_bound(bb);
        if (it == gl.end()) {
            --it;
        } else if (it != gl.begin()) {
            auto it1 = it;
            --it1;
            if (abs(it->first - bb.first) > abs(it1->first - bb.first)) {
                it = it1;
            }
        }

        ans.push_back({bb.second, it->second});
        gl.erase(it);
    }

    for (auto p : ans) {
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }

    return 0;
}