#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>

using namespace std;

typedef long long ll;

#ifdef ONPC
    mt19937 rnd(228);
#else
    mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int M = 998244353;
const int P = (M + 1) / 2;

inline int add(int a, int b)
{
    a += b;
    if (a < 0) a += M;
    if (a >= M) a -= M;
    return a;
}

inline int mul(int a, int b)
{
    return (a * (ll) b) % M;
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector <int> ret(n + 2);
    vector <int> rv(n + 2);
    ret[0] = 1;
    rv[0] = 1;
    for (int i = 1; i <= n + 1; i++)
    {
        ret[i] = mul(ret[i - 1], 2);
        rv[i] = mul(rv[i - 1], P);
    }
    vector <int> p(n, -1);
    vector <int> sz(n);
    sz[0] = 1;
    int _sum = rv[1];
    int _pep = 0;
    for (int i = 1; i < n; i++)
    {
        cin >> p[i];
        p[i]--;
        int v = i;
        _sum = add(_sum, rv[0]);
        while (v != -1)
        {
            _sum = add(_sum, -rv[sz[v]]);
            if (v != 0) _pep = add(_pep, -add(ret[sz[v]], -1));
            sz[v]++;
            if (v != 0) _pep = add(_pep, add(ret[sz[v]], -1));
            _sum = add(_sum, rv[sz[v]]);
            v = p[v];
        }
        cout << add(mul(i + 1, ret[i + 1]), -add(mul(ret[i + 1], _sum), _pep)) << ' ';
    }
    cout << '\n';
}
