#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

vector<pair<pair<int, int>, int>> v;
int solve() {
	int x, y;
	cin >> x >> y;

	int res = x ^ y;

	int ind = 2;
	while(y != 1) {
		v.push_back({{ind, 0}, 4});
		ind++;
		y = y / 2;
	}
	v.push_back({{ind, 0}, 4});

	int indR = ind + 1;
	int ind0 = indR;
	v.push_back({{ind, ind + 1}, 1});
	int power = ind + 2;

	int prevC = 1;
	for (int i = 0; (1ll << i) <= res; i++) {
		if (res & (1 << i)) {
			while (prevC < (1 << i)) {
				prevC *= 2;
				v.push_back({{power, 0}, 3});
				power++;
			}
			v.push_back({{indR, power}, 1});
			indR = power + 1;
			v.push_back({{ind0, power}, 1});
			power = power + 2;
		}
	}
	if (v.size()) v.pop_back();
	
	cout << v.size() << endl;
	for (auto x : v) {
		if (x.second > 2) {
			cout << x.second << ' ' << x.first.first << '\n';
		} else {
			cout << x.second << ' ' << x.first.first << ' ' << x.first.second << '\n';
		}
	}
	return 0;
}